//	Release Version:	$ ODF 2 $
//	Copyright:	(c) 1993 - 1996 by Apple Computer, Inc., all rights reserved.

#ifndef FRAME_H
#define FRAME_H

//=======================================================================
// ----- Framework Includes -----
#ifndef FWFRAME_H
#include <FWFrame.h>		// FW_CFrame
#endif

// ---- MacOS includes -----
#include "QD3DViewer.h"		// TQ3ViewerObject

//=======================================================================
class FW_CMenuEvent;
class FW_CPrintHandler;

//=======================================================================
class CGraphics3DFrame : public FW_CFrame {
public:
	FW_DECLARE_AUTO(CGraphics3DFrame)
	
						CGraphics3DFrame(Environment* ev, 
									ODFrame* odFrame, 
									FW_CPresentation* presentation, 
									CGraphics3DContent* content);
	virtual 			~CGraphics3DFrame();
protected:
// overrides
	virtual void		FacetAdded(Environment* ev, ODFacet* facet, 
									unsigned short facetCount);
	virtual void		Draw(Environment *ev, 
							 ODFacet* odFacet, 
							 ODShape* invalidShape);
	virtual void		FrameShapeChanged(Environment* ev);
	virtual FW_Handled	DoAdjustMenus(Environment* ev,
									  FW_CMenuBar* menuBar, 
									  FW_Boolean hasMenuFocus,
									  FW_Boolean isRoot);
	virtual FW_Handled	DoMenu(Environment* ev,
							   const FW_CMenuEvent& theMenuEvent);
	virtual FW_Handled 	DoMouseDown(Environment* ev, 
								const FW_CMouseEvent& theMouseEvent);
// overrides printing
	virtual FW_CPrintHandler*	NewPrintHandler(Environment* ev);
	virtual	FW_Boolean			IsCurrentlyPrintable(Environment* ev) const;
	virtual void				GetPrintContentExtent(Environment *ev, FW_CPoint& extent) const;
// new members
private:
	TQ3ViewerObject		fViewer;
};

//=======================================================================
#endif
