//========================================================================================
//	Release Version:	$ ODF 2 $
//	Copyright:	(c) 1993 - 1996 by Apple Computer, Inc., all rights reserved.

//================================================================================
#include "Graphics3D.hpp"

#ifndef PART_H
#include "Part.h"
#endif

#ifndef CONTENT_H
#include "Content.h"
#endif

#ifndef BINDING_K
#include "Binding.k"
#endif

#ifndef FRAME_H
#include "Frame.h"
#endif

#ifndef SELECTION_H
#include "Selection.h"
#endif

#ifndef DEFINES_K
#include "Defines.k"		// command numbers
#endif

// ----- Framework Layer -----
#ifndef FWPRESEN_H
#include "FWPresen.h"		// FW_CPresentation
#endif

#ifndef FWABOUT_H
#include "FWAbout.h"		//::FW_About()
#endif

//==============================================================================
#ifdef FW_BUILD_MAC
#pragma segment Graphics3D
#endif

FW_DEFINE_AUTO(CGraphics3DPart)

//==============================================================================
CGraphics3DPart::CGraphics3DPart(ODPart* odPart)
  :	FW_CPart(odPart, FW_gInstance, kPartInfoID),
	fPresentation(NULL),
	fPartContent(NULL)
{
}

//--------------------------------------------------------------------------------
CGraphics3DPart::~CGraphics3DPart()
{
}

//--------------------------------------------------------------------------------
void 
CGraphics3DPart::Initialize(Environment* ev, ODStorageUnit* storageUnit, 
											FW_Boolean fromStorage)	// Override
{
	FW_CPart::Initialize(ev, storageUnit, fromStorage);
	CGraphics3DSelection* selection = FW_NEW(CGraphics3DSelection, (ev, fPartContent));
	const ODType kMainPresentation = "Apple:Presentation:Graphics3D";
	const FW_Boolean kDefaultPresentation = true;
	fPresentation = RegisterPresentation(ev, kMainPresentation, 
											kDefaultPresentation, selection);
}

//--------------------------------------------------------------------------------
FW_Handled CGraphics3DPart::DoAbout(Environment* ev)
{
	::FW_About(ev, this, kAbout);
	
	return FW_kHandled;
}

//--------------------------------------------------------------------------------
FW_CFrame* 
CGraphics3DPart::NewFrame(Environment* ev, ODFrame* odFrame,
						FW_CPresentation* presentation, FW_Boolean fromStorage)	// Override
{
	FW_UNUSED(fromStorage);
	return FW_NEW(CGraphics3DFrame, (ev, odFrame, presentation, fPartContent));
}

//------------------------------------------------------------------------------
FW_CContent* 
CGraphics3DPart::NewPartContent(Environment* ev)
{
	fPartContent = FW_NEW(CGraphics3DContent, (ev, this));
	return fPartContent;
}
